#include <math.h>
#include <iostream>
#include <conio.h>
#include <vector>
#include <string>
#include "svg.h"
using namespace std;


void
svg_begin(double width, double height)
{
    cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    cout << "<svg ";
    cout << "width='" << width << "' ";
    cout << "height='" << height << "' ";
    cout << "viewBox='0 0 " << width << " " << height << "' ";
    cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void
svg_end()
{
    cout << "</svg>\n";
}
void
svg_text(double left, double baseline, string text)
{
    cout << "<text x='" << left << "' y='" << baseline << "'>" << text << "</text>";
}
void
svg_rect(double x, double y, double width, double height, string stroke, string fill)
{
    cout << "<rect x='"<<x<<"' y='"<<y<<"' width='"<<width<<"' height='"<<height<<"' stroke='"<<stroke<<"' fill='"<<fill<<"' />";

}

void
show_histogram_svg(const vector<size_t>& B, size_t& number_count)
{
/*    auto IMAGE_WIDTH=0;
    const auto BLOCK_WIDTH = 10;
    cerr << "Enter IMAGE_WIDTH:";
    cin >> IMAGE_WIDTH;

    while (IMAGE_WIDTH<70 || IMAGE_WIDTH>800 || IMAGE_WIDTH<(number_count/3.0*BLOCK_WIDTH))
    {
        cout<<"Error, incorrect IMAGE_WIDTH, please, re-enter\n";
        cerr << "Enter IMAGE_WIDTH:";
        cin >> IMAGE_WIDTH;
    }
*/
    auto IMAGE_WIDTH=200;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_LEFT = 20;
    const auto TEXT_BASELINE = 20;
    const auto TEXT_WIDTH = 50;
    const auto BIN_HEIGHT = 30;

    const auto MAX_WIDTH = IMAGE_WIDTH-TEXT_WIDTH;

    svg_begin(IMAGE_WIDTH,IMAGE_HEIGHT);

    double top = 0;
    double max_count = B[0];
    for (size_t i = 0; i < B.size(); i++)
    {
        if (max_count<B[i])
        {
            max_count=B[i];
        }
    }

    for (size_t bin : B)
    {
        double bin_width = (MAX_WIDTH)*(bin/max_count);
        svg_text(TEXT_LEFT, top+TEXT_BASELINE,to_string(bin));
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT, "black", "green");
        top += BIN_HEIGHT;
    }

    svg_end();
}
